<?php

namespace App\Http\Requests;

use Illuminate\Validation\Rule;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;

/**
 * @property mixed image
 */
class ServiceRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        if (! Auth::check()) {
            return false;
        }
        if(in_array(Auth::user()->role, ['super_admin', 'admin', 'sub_admin']))
        {
            return true;
        }

        if(Auth::user()->hasModule( 'services' ) )
        {
            return true;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $rules=[];
        foreach (languages() as $lang) {
            $lang_rules=[
                'title_'.$lang->local=> 'required|min:3',
                'desc_'.$lang->local => 'required|array',
                'icon' => 'required|array',
            ];

            $rules= array_merge($rules, $lang_rules);
        }
        foreach (languages() as $lang) {

            foreach (request()->{'desc_'.$lang->local} as $desc) {
                if (!$desc){
                    $rules['all_descriptions'] = 'required|min:3|max:100';
                }
            }

            $rules= array_merge($rules, $rules);
        }

        if (request('icon')){
            foreach (request('icon') as $icon) {
                if (!$icon){
                    $rules['all_icon'] = 'required';
                }
            }
        }

        $rules['image'] = 'required';

        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {
        $field = metaFields('services');
        $local = getCurrentLocale();
        $attributes = [
            'image' => $field[$local]['image'] ?? __('services.image'),
            'all_icon' => $field[$local]['description_icon'] ?? __('services.description_icon'),
            'all_descriptions' => $field[$local]['descriptions'] ?? __('services.descriptions'),

        ];
        foreach (languages() as $lang) {
            $lang_attributes=[
                'title_'.$lang->local=> $field[$lang->local]['title'] ?? __('services.title'),
                'desc_'.$lang->local=> $field[$lang->local]['descriptions'] ?? __('services.descriptions'),
            ];
            $attributes= array_merge($attributes, $lang_attributes);
        }
        return $attributes;
    }

    public function messages()
    {
        return [
            'images.min' => __('services.images_min') ,
        ];
    }

    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests

        if(Request::ajax()){
            $errors = $validator->errors()->first();
            throw new HttpResponseException(response()->json(['errors' => $errors]));
        } else {
            // Do the original action of the Form request class
            parent::failedValidation($validator);
        }
    }
}
